/// <reference types="node" resolution-mode="require"/>
/**
 * Indicator web component
 */
export declare class Component extends HTMLElement {
    static get observedAttributes(): string[];
    /**
     * Status indicator colors
     */
    colors: Record<string, [number, number, number, number]>;
    /**
     * Timer
     */
    timeout: NodeJS.Timeout;
    /**
     * Component name
     */
    name: string;
    /**
     * Has component rendered
     */
    rendered: boolean;
    /**
     * Class constructor
     */
    constructor();
    /**
     * Status is error
     */
    onError(): void;
    /**
     * Status is pending
     */
    onPending(): void;
    /**
     * Status is success
     */
    onSuccess(): void;
    /**
     * Status is warning
     */
    onWarning(): void;
    attributeChangedCallback(): void;
    /**
     * Get accessor: has errors
     */
    get hasErrors(): boolean;
    /**
     * Get accessor: has warnings
     */
    get hasWarnings(): boolean;
    /**
     * Hide status indicator
     */
    hide(): void;
    /**
     * Render status indicator
     */
    renderShadow(): void;
    /**
     * Root div querySelector selector
     */
    get selector(): string;
    /**
     * Show status indicator
     */
    show(): void;
}
