/// <reference types="node" resolution-mode="require"/>
/**
 * Activity indicator controller
 */
export declare class Controller {
    /**
     * DOM node
     */
    node: HTMLElement;
    /**
     * Active WHM payload
     */
    payload: any;
    /**
     * Timer handler
     */
    timer: NodeJS.Timeout;
    /**
     * Initialization
     */
    constructor();
    /**
     * Append `bud-error` element to the DOM
     */
    addNode(): void;
    /**
     * Remove `bud-error` element from the DOM (if present)
     */
    removeNode(): void;
    /**
     * Update activity indicator
     */
    update(payload: Payload): void;
}
