/**
 * Lazy import helper
 *
 * @remarks
 * Callback function may be async or sync
 *
 * @param onReady - callback function
 * @returns void
 */
interface lazy {
    <T = any>(module: Promise<{
        default: T;
    }>, handler: (module: T) => Promise<unknown> | unknown, errorHandler?: (error: unknown) => unknown): Promise<unknown>;
}
declare const lazy: lazy;
export default lazy;
