/**
 * Default error handler
 *
 * @throws Error
 */
const defaultErrorHandler = (error) => {
    throw error;
};
const lazy = async function lazy(module, handler, errorHandler) {
    try {
        const { default: request } = await module;
        return await handler(request);
    }
    catch (error) {
        const handle = errorHandler ?? defaultErrorHandler;
        handle(error);
    }
};
export default lazy;
